#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file RTC_Dummy_Pose_kv.py
 @brief poseダミー出力
 @date $Date$

 @author @author 株式会社アイザック
 研究開発部
 河野　智也
 kohno@aizuk.jp

 MIT

"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

import dummy_pose #kivy部分の .py

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
rtc_dummy_pose_kv_spec = ["implementation_id", "RTC_Dummy_Pose_kv", 
		 "type_name",         "RTC_Dummy_Pose_kv", 
		 "description",       "poseダミー出力", 
		 "version",           "1.0.0", 
		 "vendor",            "AIZUK", 
		 "category",          "TEST", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class RTC_Dummy_Pose_kv
# @brief poseダミー出力
# 
# TimedPose3D
# 
# Kivy:https://kivy.org/#home
# 
# 
class RTC_Dummy_Pose_kv(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_TimedPose3D =RTC.TimedPose3D(RTC.Time(0,0), RTC.Pose3D(RTC.Point3D(0.0,0.0,0.0), RTC.Orientation3D(0.0,0.0,0.0)))
		"""
		"""
		self._TimedPose3DOut = OpenRTM_aist.OutPort("TimedPose3D", self._d_TimedPose3D)


		self._d_TimedOrientation3D = RTC.TimedOrientation3D(RTC.Time(0,0), RTC.Orientation3D(0.0,0.0,0.0))
		"""
		"""
		self._TimedOrientation3DOut = OpenRTM_aist.OutPort("TimedOrientation3D", self._d_TimedOrientation3D)
		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		#self._d_TimedOrientation3D
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		
		# Set OutPort buffers
		self.addOutPort("TimedPose3D",self._TimedPose3DOut)
		self.addOutPort("TimedOrientation3D",self._TimedOrientation3DOut)
		
		# Set service prself._d_TimedOrientation3Dovider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
		##
		# 
		# The finalize action (on ALIVE->END transition)
		# formaer rtc_exiting_entry()
		# 
		# @return RTC::ReturnCode_t
	
		# 
	def onFinalize(self):
	
		return RTC.RTC_OK
	
		##
		#
		# The startup action when ExecutionContext startup
		# former rtc_starting_entry()
		# 
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onStartup(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The shutdown action when ExecutionContext stop
		# former rtc_stopping_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onShutdown(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The deactivated action (Active state exit action)
		# former rtc_active_exit()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
	        #global GUI
		Get = dummy_pose.Get()#dummy_pose GET class
		dat=[]
		dat=10*[0]
		
		dat =  Get.get_Pose()#datにスライダーからの角度データ格納　[0]:Roll [1];Pitch [2]Yaw
		
		#位置は０
		self._d_TimedPose3D.data.position.x = 0
		self._d_TimedPose3D.data.position.y = 0
		self._d_TimedPose3D.data.position.z = 0
		#姿勢　それぞれ代入
		self._d_TimedPose3D.data.orientation.r  = dat[0]
		self._d_TimedPose3D.data.orientation.p  = dat[1]
		self._d_TimedPose3D.data.orientation.y  = dat[2]
		self._TimedPose3DOut.write()#TimedPose3D
		self._d_TimedOrientation3D.data.r  = dat[0]
		self._d_TimedOrientation3D.data.p  = dat[1]
		self._d_TimedOrientation3D.data.y  = dat[2]
		self._TimedOrientation3DOut.write()#TimedOrientation3D
		return RTC.RTC_OK
	
		##
		#
		# The aborting action when main logic error occurred.
		# former rtc_aborting_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onAborting(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The error action in ERROR state
		# former rtc_error_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onError(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The reset action that is invoked resetting
		# This is same but different the former rtc_init_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onReset(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The state update action that is invoked after onExecute() action
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#

		#
	def onStateUpdate(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The action that is invoked when execution context's rate is changed
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onRateChanged(self, ec_id):
	
		return RTC.RTC_OK
	



def RTC_Dummy_Pose_kvInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=rtc_dummy_pose_kv_spec)
    manager.registerFactory(profile,
                            RTC_Dummy_Pose_kv,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    RTC_Dummy_Pose_kvInit(manager)

    # Create a component
    comp = manager.createComponent("RTC_Dummy_Pose_kv")

def main():
	#global GUI
	#GUI=dummy_pose.RootWidget()
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	#mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
        RTC_Dummy_Pose_kvInit(mgr)
	mgr.runManager(True)
        comp = mgr.createComponent("RTC_Dummy_Pose_kv")
        GUI_kivy = dummy_pose.dummy_poseApp().run()

if __name__ == "__main__":
	main()

